﻿'use strict';
//# sourceMappingURL=contentscript.js.map

window.addEventListener('load', function () {
  setTimeout(readGoogleLinks, 1000);
}, false);

// Utility Function
function findChildByClass(element, className) {
  var foundElement = null;
  function recurse(element, className, found) {
    for (var i = 0; i < element.childNodes.length && !found; i++) {
      var el = element.childNodes[i];
      var classes = el.className !== undefined ? el.className.split(' ') : [];
      for (var j = 0, jl = classes.length; j < jl; j++) {
        if (classes[j] === className) {
          found = true;
          foundElement = element.childNodes[i];
          break;
        }
      }
      if (found) {
        break;
      }
      recurse(element.childNodes[i], className, found);
    }
  }
  recurse(element, className, false);
  return foundElement;
}

function readGoogleLinks() {
  var searchBox = document.getElementsByClassName('srg')[0];
  if (!searchBox) {
    console.info('no searchbox');
    chrome.runtime.sendMessage({ msg: 'newLinks', links: [] });
    return;
  }

  var entries = searchBox.childNodes; // Google search Entries
  var siteLinks = [];

  for (var i = 0; i < entries.length; i++) {
    var entryHeader = findChildByClass(entries[i], 'r');// entryHeader (blue heading)
    var headerLink = entryHeader.firstChild;
    var siteLink = headerLink.href;

    if (siteLink.indexOf('https://www.xing.com/profile/') > -1) {
      // xing pages are okay -> push to Array
    } else if (siteLink.indexOf('.linkedin.com') > -1 && siteLink.indexOf('/dir/') === -1 && siteLink.indexOf('/company/') === -1) {
      // linkedin pages are okay -> push to Array
    } else {
      // everything else is not okay :P
      continue;
    }

    siteLinks.push(siteLink);
  }
  console.info(siteLinks);
  chrome.runtime.sendMessage({ msg: 'newLinks', links: siteLinks });
}

