/* global window, document, MutationObserver, $, self */

(function () {
  'use strict';

  function getCSRFToken() {
    let cookieString = document.cookie;
    let cookies = cookieString.split(';').map(s => s.trim());

    let csrfCookie = cookies.find(c => c.startsWith('JSESSIONID'));

    if (!csrfCookie) {
      return null;
    }

    let tmp = csrfCookie.split('=')[1];

    return tmp.substring(1, tmp.length - 1);
  }

  function sendCSRFToken(parent, origin) {
    const csrfToken = getCSRFToken();
    parent.postMessage('tkn:' + csrfToken, origin);
  }

  function receiveMessage(e) {
    if (e.data === 'get_linkedin_data') {
      sendCSRFToken(e.source, e.origin);
    }
  }

  window.addEventListener('message', receiveMessage, false);

})();

