'use strict';

var iframeOpen = null;

chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.toggleSidebar) {
      if (!iframeOpen) {
        var url = chrome.extension.getURL('/popup_dist/index.html'),
          wrapper = document.createElement('div'),
          iframe = document.createElement('iframe'),
          toggleButton = document.createElement('div'),
          dragBar = document.createElement('div'),
          shieldingDiv = document.createElement('div');

        wrapper.className = 'snapaddy-sidebar-wrap';
        dragBar.className = 'snapaddy-sidebar-drag ui-resizable-handle ui-resizable-w';

        shieldingDiv.className = 'snapaddy-sidebar-shielding';

        iframe.src = url;
        iframe.className = 'snapaddy-sidebar';
        iframeOpen = iframe;

        toggleButton.id = 'snapaddy-sidebar-toggle';
        toggleButton.className = 'snapaddy-sidebar-toggle';
        toggleButton.onclick = function () {
          var wrapperClass = wrapper.className === 'snapaddy-sidebar-wrap' ? 'snapaddy-sidebar-wrap snapaddy-sidebar-wrap--hidden' : 'snapaddy-sidebar-wrap';

          wrapper.className = wrapperClass;
          if (wrapperClass === 'snapaddy-sidebar-wrap snapaddy-sidebar-wrap--hidden') {
            chrome.runtime.sendMessage({ sidebarHidden: true });
          }
        };

        chrome.storage.local.get('sidebarWidth', function (e) {
          if (e.sidebarWidth) {
            wrapper.style.width = e.sidebarWidth + 'px';
          }
          wrapper.appendChild(iframe);
          wrapper.appendChild(toggleButton);
          wrapper.appendChild(dragBar);
          wrapper.appendChild(shieldingDiv);
          document.body.appendChild(wrapper);

          // Setup drag functionality
          dragBar.onmousedown = () => {
            console.log('START DRAG');
            $('.snapaddy-sidebar-shielding').css('pointer-events', 'all');
            // Disable text selection while dragging
            document.onselectstart = () => {
              return false;
            };
            document.onmousemove = (event) => {
              let widthToSet = window.innerWidth - event.clientX;
              if (widthToSet < 360) {
                widthToSet = 360;
              }
              if (widthToSet > window.innerWidth / 2) {
                widthToSet = window.innerWidth / 2;
              }
              wrapper.style.width = widthToSet + 'px';
            };
            const finishSlide = (event) => {
              console.log('END DRAG');
              $('.snapaddy-sidebar-shielding').css('pointer-events', 'none');
              document.onmouseup = null;
              document.onmousemove = null;
              document.onmouseout = null;
              document.onselectstart = null;
              let widthToSave = window.innerWidth - event.clientX;
              if (widthToSave < 360) {
                widthToSave = 360;
              }
              if (widthToSave > window.innerWidth / 2) {
                widthToSave = window.innerWidth / 2;
              }
              chrome.storage.local.set({
                'sidebarWidth': widthToSave
              });
            };
            // If mouse leaves the document
            document.onmouseup = finishSlide;
            document.onmouseout = (event) => {
              let from = event.relatedTarget;
              if (!from || from.nodeName === 'HTML') {
                console.log('MOUSE OUT');
                finishSlide(event);
              }
            };
          };
        });
      } else {
        var wrap = $('.snapaddy-sidebar-wrap')[0];
        wrap.parentNode.removeChild(wrap);
        iframeOpen = null;
      }
    }
    if (request.isSidebarVisible) {
      sendResponse((iframeOpen !== null));
    }
    if (request.sidebarUnHide) {
      iframeOpen.className = 'snapaddy-sidebar';
      var sidebarWrapper = document.getElementsByClassName('snapaddy-sidebar-wrap snapaddy-sidebar-wrap--hidden');
      if (sidebarWrapper.length > 0) {
        sidebarWrapper[0].className = 'snapaddy-sidebar-wrap';
      }
    }
  }
);

chrome.runtime.sendMessage({ contentScriptLoaded: true });
